import { BelongsTo } from './metadata/belongsto';
import { Contributor } from './metadata/contributor';
import { IStringMap } from './metadata/multilang';
import { Subject } from './metadata/subject';
export declare class Metadata {
    type: string;
    identifier: string;
    title: string | IStringMap;
    subtitle: string | IStringMap;
    modified: Date;
    published: Date;
    language: string[];
    sortAs: string;
    author: Contributor[];
    translator: Contributor[];
    editor: Contributor[];
    artist: Contributor[];
    illustrator: Contributor[];
    letterer: Contributor[];
    penciler: Contributor[];
    colorist: Contributor[];
    inker: Contributor[];
    narrator: Contributor[];
    contributor: Contributor[];
    publisher: Contributor[];
    imprint: Contributor[];
    readingProgression: 'auto' | 'ltr' | 'rtl';
    description: string;
    duration: number;
    numberOfPages: number;
    belongsTo: BelongsTo;
    subject: Subject[];
    private _OnDeserialized;
}
