var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Publication_1;
import { JSON as TaJson, JsonConverter, JsonElementType, JsonObject, JsonProperty, OnDeserialized, propertyConverters, } from 'ta-json-x';
import { JsonStringConverter } from './converters/string-converter';
import { JsonDateConverter } from './converters/date-converter';
import { JsonNumberConverter } from './converters/number-converter';
propertyConverters.set(Date, new JsonDateConverter());
propertyConverters.set(Number, new JsonNumberConverter());
import { Metadata } from './metadata';
import { Link } from './link';
let Publication = Publication_1 = class Publication {
    static parse(json) {
        return TaJson.parse(json, Publication_1);
    }
    stringify() {
        return TaJson.stringify(this);
    }
    static deserialize(object) {
        return TaJson.deserialize(object, Publication_1);
    }
    serialize() {
        return TaJson.serialize(this);
    }
    _OnDeserialized() {
        /* istanbul ignore next */
        if (!this.metadata) {
            console.log('Required [Publication.Metadata] is not set!');
        }
        /* istanbul ignore next */
        if (!this.links) {
            console.log('Required [Publication.Links] is not set!');
        }
        /* istanbul ignore next */
        if (!this.readingOrder) {
            console.log('Required [Publication.ReadingOrder] is not set!');
        }
    }
};
__decorate([
    JsonConverter(JsonStringConverter),
    JsonProperty('@context'),
    JsonElementType(String),
    __metadata("design:type", Array)
], Publication.prototype, "context", void 0);
__decorate([
    JsonProperty('metadata'),
    __metadata("design:type", Metadata)
], Publication.prototype, "metadata", void 0);
__decorate([
    JsonProperty('links'),
    JsonElementType(Link),
    __metadata("design:type", Array)
], Publication.prototype, "links", void 0);
__decorate([
    JsonProperty('readingOrder'),
    JsonElementType(Link),
    __metadata("design:type", Array)
], Publication.prototype, "readingOrder", void 0);
__decorate([
    JsonProperty('resources'),
    JsonElementType(Link),
    __metadata("design:type", Array)
], Publication.prototype, "resources", void 0);
__decorate([
    OnDeserialized(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], Publication.prototype, "_OnDeserialized", null);
Publication = Publication_1 = __decorate([
    JsonObject()
], Publication);
export { Publication };
//# sourceMappingURL=publication.js.map